/* soapOrdersManagerBindingService.cpp
   Generated by gSOAP 2.8.22 from OrdersManager.h

Copyright(C) 2000-2015, Robert van Engelen, Genivia Inc. All Rights Reserved.
The generated code is released under one of the following licenses:
GPL or Genivia's license for commercial use.
This program is released under the GPL with the additional exemption that
compiling, linking, and/or using OpenSSL is allowed.
*/

#include "soapOrdersManagerBindingService.h"

OrdersManagerBindingService::OrdersManagerBindingService()
{	this->soap = soap_new();
	this->soap_own = true;
	OrdersManagerBindingService_init(SOAP_IO_DEFAULT, SOAP_IO_DEFAULT);
}

OrdersManagerBindingService::OrdersManagerBindingService(struct soap *_soap)
{	this->soap = _soap;
	this->soap_own = false;
	OrdersManagerBindingService_init(_soap->imode, _soap->omode);
}

OrdersManagerBindingService::OrdersManagerBindingService(soap_mode iomode)
{	this->soap = soap_new();
	this->soap_own = true;
	OrdersManagerBindingService_init(iomode, iomode);
}

OrdersManagerBindingService::OrdersManagerBindingService(soap_mode imode, soap_mode omode)
{	this->soap = soap_new();
	this->soap_own = true;
	OrdersManagerBindingService_init(imode, omode);
}

OrdersManagerBindingService::~OrdersManagerBindingService()
{	if (this->soap_own)
		soap_free(this->soap);
}

void OrdersManagerBindingService::OrdersManagerBindingService_init(soap_mode imode, soap_mode omode)
{	soap_imode(this->soap, imode);
	soap_omode(this->soap, omode);
	static const struct Namespace namespaces[] =
{
	{"SOAP-ENV", "http://www.w3.org/2003/05/soap-envelope", "http://schemas.xmlsoap.org/soap/envelope/", NULL},
	{"SOAP-ENC", "http://www.w3.org/2003/05/soap-encoding", "http://schemas.xmlsoap.org/soap/encoding/", NULL},
	{"xsi", "http://www.w3.org/2001/XMLSchema-instance", "http://www.w3.org/*/XMLSchema-instance", NULL},
	{"xsd", "http://www.w3.org/2001/XMLSchema", "http://www.w3.org/*/XMLSchema", NULL},
	{"ns1", "http://www.ordersmanager.ru/", NULL, NULL},
	{NULL, NULL, NULL, NULL}
};
	soap_set_namespaces(this->soap, namespaces);
}

void OrdersManagerBindingService::destroy()
{	soap_destroy(this->soap);
	soap_end(this->soap);
}

void OrdersManagerBindingService::reset()
{	destroy();
	soap_done(this->soap);
	soap_initialize(this->soap);
	OrdersManagerBindingService_init(SOAP_IO_DEFAULT, SOAP_IO_DEFAULT);
}

#ifndef WITH_PURE_VIRTUAL
OrdersManagerBindingService *OrdersManagerBindingService::copy()
{	OrdersManagerBindingService *dup = SOAP_NEW_COPY(OrdersManagerBindingService);
	if (dup)
		soap_copy_context(dup->soap, this->soap);
	return dup;
}
#endif

int OrdersManagerBindingService::soap_close_socket()
{	return soap_closesock(this->soap);
}

int OrdersManagerBindingService::soap_force_close_socket()
{	return soap_force_closesock(this->soap);
}

int OrdersManagerBindingService::soap_senderfault(const char *string, const char *detailXML)
{	return ::soap_sender_fault(this->soap, string, detailXML);
}

int OrdersManagerBindingService::soap_senderfault(const char *subcodeQName, const char *string, const char *detailXML)
{	return ::soap_sender_fault_subcode(this->soap, subcodeQName, string, detailXML);
}

int OrdersManagerBindingService::soap_receiverfault(const char *string, const char *detailXML)
{	return ::soap_receiver_fault(this->soap, string, detailXML);
}

int OrdersManagerBindingService::soap_receiverfault(const char *subcodeQName, const char *string, const char *detailXML)
{	return ::soap_receiver_fault_subcode(this->soap, subcodeQName, string, detailXML);
}

void OrdersManagerBindingService::soap_print_fault(FILE *fd)
{	::soap_print_fault(this->soap, fd);
}

#ifndef WITH_LEAN
#ifndef WITH_COMPAT
void OrdersManagerBindingService::soap_stream_fault(std::ostream& os)
{	::soap_stream_fault(this->soap, os);
}
#endif

char *OrdersManagerBindingService::soap_sprint_fault(char *buf, size_t len)
{	return ::soap_sprint_fault(this->soap, buf, len);
}
#endif

void OrdersManagerBindingService::soap_noheader()
{	this->soap->header = NULL;
}

const SOAP_ENV__Header *OrdersManagerBindingService::soap_header()
{	return this->soap->header;
}

int OrdersManagerBindingService::run(int port)
{	if (soap_valid_socket(this->soap->master) || soap_valid_socket(bind(NULL, port, 100)))
	{	for (;;)
		{	if (!soap_valid_socket(accept()) || serve())
				break;
			soap_destroy(this->soap);
			soap_end(this->soap);
		}
	}
	return this->soap->error;
}

SOAP_SOCKET OrdersManagerBindingService::bind(const char *host, int port, int backlog)
{	return soap_bind(this->soap, host, port, backlog);
}

SOAP_SOCKET OrdersManagerBindingService::accept()
{	return soap_accept(this->soap);
}

#if defined(WITH_OPENSSL) || defined(WITH_GNUTLS)
int OrdersManagerBindingService::ssl_accept()
{	return soap_ssl_accept(this->soap);
}
#endif

int OrdersManagerBindingService::serve()
{
#ifndef WITH_FASTCGI
	unsigned int k = this->soap->max_keep_alive;
#endif
	do
	{

#ifndef WITH_FASTCGI
		if (this->soap->max_keep_alive > 0 && !--k)
			this->soap->keep_alive = 0;
#endif

		if (soap_begin_serve(this->soap))
		{	if (this->soap->error >= SOAP_STOP)
				continue;
			return this->soap->error;
		}
		if (dispatch() || (this->soap->fserveloop && this->soap->fserveloop(this->soap)))
		{
#ifdef WITH_FASTCGI
			soap_send_fault(this->soap);
#else
			return soap_send_fault(this->soap);
#endif
		}

#ifdef WITH_FASTCGI
		soap_destroy(this->soap);
		soap_end(this->soap);
	} while (1);
#else
	} while (this->soap->keep_alive);
#endif
	return SOAP_OK;
}

static int serve___ns1__GetResponseCodeString(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__GetUserId(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__GetBusinessName(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__GetIdBusinessList(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__GetUserInfo(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__Registration(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__Authorization(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__SendOrder(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__TakeOrder(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__FinishOrder(struct soap*, OrdersManagerBindingService*);
static int serve___ns1__FindOrders(struct soap*, OrdersManagerBindingService*);

int OrdersManagerBindingService::dispatch()
{	return dispatch(this->soap);
}

int OrdersManagerBindingService::dispatch(struct soap* soap)
{	OrdersManagerBindingService_init(soap->imode, soap->omode);
	soap_peek_element(soap);
	if (!soap_match_tag(soap, soap->tag, "code"))
		return serve___ns1__GetResponseCodeString(soap, this);
	if (!soap_match_tag(soap, soap->tag, "str"))
		return serve___ns1__GetUserId(soap, this);
	if (!soap_match_tag(soap, soap->tag, "idBusiness"))
		return serve___ns1__GetBusinessName(soap, this);
	if (!soap_match_tag(soap, soap->tag, "idParent"))
		return serve___ns1__GetIdBusinessList(soap, this);
	if (!soap_match_tag(soap, soap->tag, "idUser"))
		return serve___ns1__GetUserInfo(soap, this);
	if (!soap_match_tag(soap, soap->tag, "info"))
		return serve___ns1__Registration(soap, this);
	if (!soap_match_tag(soap, soap->tag, "authInfo"))
		return serve___ns1__Authorization(soap, this);
	if (!soap_match_tag(soap, soap->tag, "order"))
		return serve___ns1__SendOrder(soap, this);
	if (!soap_match_tag(soap, soap->tag, "takeId"))
		return serve___ns1__TakeOrder(soap, this);
	if (!soap_match_tag(soap, soap->tag, "finishId"))
		return serve___ns1__FinishOrder(soap, this);
	if (!soap_match_tag(soap, soap->tag, "query"))
		return serve___ns1__FindOrders(soap, this);
	return soap->error = SOAP_NO_METHOD;
}

static int serve___ns1__GetResponseCodeString(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__GetResponseCodeString soap_tmp___ns1__GetResponseCodeString;
	struct __ns1__GetResponseCodeStringResponse soap_tmp___ns1__GetResponseCodeStringResponse;
	soap_default___ns1__GetResponseCodeStringResponse(soap, &soap_tmp___ns1__GetResponseCodeStringResponse);
	soap_default___ns1__GetResponseCodeString(soap, &soap_tmp___ns1__GetResponseCodeString);
	if (!soap_get___ns1__GetResponseCodeString(soap, &soap_tmp___ns1__GetResponseCodeString, "-ns1:GetResponseCodeString", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->GetResponseCodeString(soap_tmp___ns1__GetResponseCodeString.code, soap_tmp___ns1__GetResponseCodeStringResponse.str);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__GetResponseCodeStringResponse(soap, &soap_tmp___ns1__GetResponseCodeStringResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__GetResponseCodeStringResponse(soap, &soap_tmp___ns1__GetResponseCodeStringResponse, "-ns1:GetResponseCodeStringResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__GetResponseCodeStringResponse(soap, &soap_tmp___ns1__GetResponseCodeStringResponse, "-ns1:GetResponseCodeStringResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__GetUserId(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__GetUserId soap_tmp___ns1__GetUserId;
	struct __ns1__GetUserIdResponse soap_tmp___ns1__GetUserIdResponse;
	soap_default___ns1__GetUserIdResponse(soap, &soap_tmp___ns1__GetUserIdResponse);
	soap_default___ns1__GetUserId(soap, &soap_tmp___ns1__GetUserId);
	if (!soap_get___ns1__GetUserId(soap, &soap_tmp___ns1__GetUserId, "-ns1:GetUserId", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->GetUserId(soap_tmp___ns1__GetUserId.str, soap_tmp___ns1__GetUserIdResponse.value);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__GetUserIdResponse(soap, &soap_tmp___ns1__GetUserIdResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__GetUserIdResponse(soap, &soap_tmp___ns1__GetUserIdResponse, "-ns1:GetUserIdResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__GetUserIdResponse(soap, &soap_tmp___ns1__GetUserIdResponse, "-ns1:GetUserIdResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__GetBusinessName(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__GetBusinessName soap_tmp___ns1__GetBusinessName;
	struct __ns1__GetBusinessNameResponse soap_tmp___ns1__GetBusinessNameResponse;
	soap_default___ns1__GetBusinessNameResponse(soap, &soap_tmp___ns1__GetBusinessNameResponse);
	soap_default___ns1__GetBusinessName(soap, &soap_tmp___ns1__GetBusinessName);
	if (!soap_get___ns1__GetBusinessName(soap, &soap_tmp___ns1__GetBusinessName, "-ns1:GetBusinessName", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->GetBusinessName(soap_tmp___ns1__GetBusinessName.idBusiness, soap_tmp___ns1__GetBusinessNameResponse.str);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__GetBusinessNameResponse(soap, &soap_tmp___ns1__GetBusinessNameResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__GetBusinessNameResponse(soap, &soap_tmp___ns1__GetBusinessNameResponse, "-ns1:GetBusinessNameResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__GetBusinessNameResponse(soap, &soap_tmp___ns1__GetBusinessNameResponse, "-ns1:GetBusinessNameResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__GetIdBusinessList(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__GetIdBusinessList soap_tmp___ns1__GetIdBusinessList;
	ns1__idListType idBussinessList;
	idBussinessList.soap_default(soap);
	soap_default___ns1__GetIdBusinessList(soap, &soap_tmp___ns1__GetIdBusinessList);
	if (!soap_get___ns1__GetIdBusinessList(soap, &soap_tmp___ns1__GetIdBusinessList, "-ns1:GetIdBusinessList", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->GetIdBusinessList(soap_tmp___ns1__GetIdBusinessList.idParent, idBussinessList);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	idBussinessList.soap_serialize(soap);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || idBussinessList.soap_put(soap, "idBussinessList", "")
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || idBussinessList.soap_put(soap, "idBussinessList", "")
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__GetUserInfo(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__GetUserInfo soap_tmp___ns1__GetUserInfo;
	ns1__clientBaseInfoType userInfo;
	userInfo.soap_default(soap);
	soap_default___ns1__GetUserInfo(soap, &soap_tmp___ns1__GetUserInfo);
	if (!soap_get___ns1__GetUserInfo(soap, &soap_tmp___ns1__GetUserInfo, "-ns1:GetUserInfo", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->GetUserInfo(soap_tmp___ns1__GetUserInfo.idUser, userInfo);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	userInfo.soap_serialize(soap);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || userInfo.soap_put(soap, "userInfo", "")
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || userInfo.soap_put(soap, "userInfo", "")
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__Registration(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__Registration soap_tmp___ns1__Registration;
	struct __ns1__RegistrationResponse soap_tmp___ns1__RegistrationResponse;
	soap_default___ns1__RegistrationResponse(soap, &soap_tmp___ns1__RegistrationResponse);
	soap_default___ns1__Registration(soap, &soap_tmp___ns1__Registration);
	if (!soap_get___ns1__Registration(soap, &soap_tmp___ns1__Registration, "-ns1:Registration", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->Registration(soap_tmp___ns1__Registration.info, soap_tmp___ns1__RegistrationResponse.code);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__RegistrationResponse(soap, &soap_tmp___ns1__RegistrationResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__RegistrationResponse(soap, &soap_tmp___ns1__RegistrationResponse, "-ns1:RegistrationResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__RegistrationResponse(soap, &soap_tmp___ns1__RegistrationResponse, "-ns1:RegistrationResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__Authorization(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__Authorization soap_tmp___ns1__Authorization;
	struct __ns1__AuthorizationResponse soap_tmp___ns1__AuthorizationResponse;
	soap_default___ns1__AuthorizationResponse(soap, &soap_tmp___ns1__AuthorizationResponse);
	soap_default___ns1__Authorization(soap, &soap_tmp___ns1__Authorization);
	if (!soap_get___ns1__Authorization(soap, &soap_tmp___ns1__Authorization, "-ns1:Authorization", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->Authorization(soap_tmp___ns1__Authorization.authInfo, soap_tmp___ns1__AuthorizationResponse.code);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__AuthorizationResponse(soap, &soap_tmp___ns1__AuthorizationResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__AuthorizationResponse(soap, &soap_tmp___ns1__AuthorizationResponse, "-ns1:AuthorizationResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__AuthorizationResponse(soap, &soap_tmp___ns1__AuthorizationResponse, "-ns1:AuthorizationResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__SendOrder(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__SendOrder soap_tmp___ns1__SendOrder;
	struct __ns1__SendOrderResponse soap_tmp___ns1__SendOrderResponse;
	soap_default___ns1__SendOrderResponse(soap, &soap_tmp___ns1__SendOrderResponse);
	soap_default___ns1__SendOrder(soap, &soap_tmp___ns1__SendOrder);
	if (!soap_get___ns1__SendOrder(soap, &soap_tmp___ns1__SendOrder, "-ns1:SendOrder", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->SendOrder(soap_tmp___ns1__SendOrder.order, soap_tmp___ns1__SendOrder.auth, soap_tmp___ns1__SendOrderResponse.code);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__SendOrderResponse(soap, &soap_tmp___ns1__SendOrderResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__SendOrderResponse(soap, &soap_tmp___ns1__SendOrderResponse, "-ns1:SendOrderResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__SendOrderResponse(soap, &soap_tmp___ns1__SendOrderResponse, "-ns1:SendOrderResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__TakeOrder(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__TakeOrder soap_tmp___ns1__TakeOrder;
	struct __ns1__TakeOrderResponse soap_tmp___ns1__TakeOrderResponse;
	soap_default___ns1__TakeOrderResponse(soap, &soap_tmp___ns1__TakeOrderResponse);
	soap_default___ns1__TakeOrder(soap, &soap_tmp___ns1__TakeOrder);
	if (!soap_get___ns1__TakeOrder(soap, &soap_tmp___ns1__TakeOrder, "-ns1:TakeOrder", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->TakeOrder(soap_tmp___ns1__TakeOrder.takeId, soap_tmp___ns1__TakeOrder.auth, soap_tmp___ns1__TakeOrderResponse.code);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__TakeOrderResponse(soap, &soap_tmp___ns1__TakeOrderResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__TakeOrderResponse(soap, &soap_tmp___ns1__TakeOrderResponse, "-ns1:TakeOrderResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__TakeOrderResponse(soap, &soap_tmp___ns1__TakeOrderResponse, "-ns1:TakeOrderResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__FinishOrder(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__FinishOrder soap_tmp___ns1__FinishOrder;
	struct __ns1__FinishOrderResponse soap_tmp___ns1__FinishOrderResponse;
	soap_default___ns1__FinishOrderResponse(soap, &soap_tmp___ns1__FinishOrderResponse);
	soap_default___ns1__FinishOrder(soap, &soap_tmp___ns1__FinishOrder);
	if (!soap_get___ns1__FinishOrder(soap, &soap_tmp___ns1__FinishOrder, "-ns1:FinishOrder", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->FinishOrder(soap_tmp___ns1__FinishOrder.finishId, soap_tmp___ns1__FinishOrder.auth, soap_tmp___ns1__FinishOrderResponse.code);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__FinishOrderResponse(soap, &soap_tmp___ns1__FinishOrderResponse);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__FinishOrderResponse(soap, &soap_tmp___ns1__FinishOrderResponse, "-ns1:FinishOrderResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__FinishOrderResponse(soap, &soap_tmp___ns1__FinishOrderResponse, "-ns1:FinishOrderResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}

static int serve___ns1__FindOrders(struct soap *soap, OrdersManagerBindingService *service)
{	struct __ns1__FindOrders soap_tmp___ns1__FindOrders;
	struct __ns1__FindOrdersResponse _param_1;
	soap_default___ns1__FindOrdersResponse(soap, &_param_1);
	soap_default___ns1__FindOrders(soap, &soap_tmp___ns1__FindOrders);
	if (!soap_get___ns1__FindOrders(soap, &soap_tmp___ns1__FindOrders, "-ns1:FindOrders", NULL))
		return soap->error;
	if (soap_body_end_in(soap)
	 || soap_envelope_end_in(soap)
	 || soap_end_recv(soap))
		return soap->error;
	soap->error = service->FindOrders(soap_tmp___ns1__FindOrders.query, soap_tmp___ns1__FindOrders.auth, _param_1);
	if (soap->error)
		return soap->error;
	soap->encodingStyle = NULL;
	soap_serializeheader(soap);
	soap_serialize___ns1__FindOrdersResponse(soap, &_param_1);
	if (soap_begin_count(soap))
		return soap->error;
	if (soap->mode & SOAP_IO_LENGTH)
	{	if (soap_envelope_begin_out(soap)
		 || soap_putheader(soap)
		 || soap_body_begin_out(soap)
		 || soap_put___ns1__FindOrdersResponse(soap, &_param_1, "-ns1:FindOrdersResponse", NULL)
		 || soap_body_end_out(soap)
		 || soap_envelope_end_out(soap))
			 return soap->error;
	};
	if (soap_end_count(soap)
	 || soap_response(soap, SOAP_OK)
	 || soap_envelope_begin_out(soap)
	 || soap_putheader(soap)
	 || soap_body_begin_out(soap)
	 || soap_put___ns1__FindOrdersResponse(soap, &_param_1, "-ns1:FindOrdersResponse", NULL)
	 || soap_body_end_out(soap)
	 || soap_envelope_end_out(soap)
	 || soap_end_send(soap))
		return soap->error;
	return soap_closesock(soap);
}
/* End of server object code */
